#include "pport.h"
#include "pportdefs.h"
#include <jni.h>
/*
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
*/


JNIEXPORT jbyte JNICALL Java_org_halfdog_io_parport_WindowsParPort_read
  (JNIEnv *env, jobject this) {

  jclass		ppclass;
  int			baseport;

  ppclass = (*env)->GetObjectClass(env, this);
  baseport = (*env)->GetIntField(env, this, (*env)->GetFieldID(env, ppclass, "baseport", "I"));

  return(inportb(baseport));
}


JNIEXPORT void JNICALL Java_org_halfdog_io_parport_WindowsParPort_write
  (JNIEnv *env, jobject this, jbyte value) {
  jclass                ppclass;
  int                   baseport;

  ppclass = (*env)->GetObjectClass(env, this);

  baseport = (*env)->GetIntField(env, this, (*env)->GetFieldID(env, ppclass, "baseport", "I"));

  outportb(baseport, value);
}


/*
 * Class:     org_halfdog_io_parport_WindowsParPort
 * Method:    readStatus
 * Signature: ()B
 */
JNIEXPORT jbyte JNICALL Java_org_halfdog_io_parport_WindowsParPort_readStatus
  (JNIEnv *env, jobject this) {

  jclass                ppclass;
  int                   baseport;

  ppclass = (*env)->GetObjectClass(env, this);

  baseport = (*env)->GetIntField(env, this, (*env)->GetFieldID(env, ppclass, "baseport", "I"));

  return(inportb(baseport+1));
}



/*
 * Class:     org_halfdog_io_parport_WindowsParPort
 * Method:    writeControl
 * Signature: (B)V
 */
JNIEXPORT void JNICALL Java_org_halfdog_io_parport_WindowsParPort_writeControl
  (JNIEnv *env, jobject this, jbyte value) {
  jclass                ppclass;
  int                   baseport;

  ppclass = (*env)->GetObjectClass(env, this);

  baseport = (*env)->GetIntField(env, this, (*env)->GetFieldID(env, ppclass, "baseport", "I"));

  outportb(baseport+2, value);
}

/*
 * Class:     org_halfdog_io_parport_WindowsParPort
 * Method:    executeSequence
 * Signature: ([B[B)V
 */
JNIEXPORT void JNICALL Java_org_halfdog_io_parport_WindowsParPort_executeSequence
  (JNIEnv *env, jobject this, jbyteArray sequencearg, jbyteArray retvalarg) {
  jclass                ppclass;
  int			command;
  int                   baseport, seqelems, seqcnt;
  int			resultpos;
  char			*sequence, *retval;

  ppclass = (*env)->GetObjectClass(env, this);

  baseport = (*env)->GetIntField(env, this, (*env)->GetFieldID(env, ppclass, "baseport", "I"));

  sequence=(*env)->GetByteArrayElements(env, sequencearg, 0);
  retval=(*env)->GetByteArrayElements(env, retvalarg, 0);

  memcpy(&seqelems, sequence, 4);

  resultpos=0;
  for(seqcnt=0; seqcnt<seqelems; seqcnt++) {
    memcpy(&command, sequence+(seqcnt<<2)+4, 4);

    switch(command&0x3) {
      case PPORT_WBYTE:
        outb((command>>8)&0xFF, baseport);
        break;
      case PPORT_WSTATUS:
        outb((command>>8)&0xFF, baseport+2);
        break;
      case PPORT_RBYTE:
        retval[resultpos++]=((inb(baseport)&0xFF)<<8);
        break;
      case PPORT_RSTATUS:
        retval[resultpos++]=((inb(baseport+1)&0xFF)<<8);
        break;
    }
    command=(command>>16)&0xFFFF;
    if(command>0) udelay(command);
  }

// copy back
  (*env)->ReleaseByteArrayElements(env, sequencearg, sequence, 0);
  (*env)->ReleaseByteArrayElements(env, retvalarg, retval, 0);
}



