package org.halfdog.io.parport;

import java.io.IOException;

/** Just pass the calls to the underlying java native library
*/

public class WindowsParPort extends ParPort {

  private int		baseport;

  public WindowsParPort(int baseport) throws IOException {
    this.baseport=baseport;
  }


  public native synchronized byte read() throws IOException;
  public native synchronized void write(byte b) throws IOException;
  public native synchronized byte readStatus() throws IOException;
  public native synchronized void writeControl(byte b) throws IOException;



  public Sequence createSequence() {
    return(new GenericSequence());
  }



/** Execute a sequence. This feature is used to execute timing
 *  critical commands in a very fast way.
*/
  public synchronized byte[] doSequence(Sequence seq) throws IOException {
    byte data[], buf[];

    data=((GenericSequence)seq).getSequence();
    buf=new byte[((GenericSequence)seq).getReadCount()];

    executeSequence(data, buf);
    return(buf);
  }


  private native void executeSequence(byte data[], byte ret[]) throws IOException;

}




